-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

indexing
	cluster: Pylon, Container
	description: "Abstract dispenser"
	interface: abstract

deferred class P_DISPENSER[G]

inherit
	P_CONTAINER[G]
		end

feature -- Update
	
	add(it: G) is
			-- Add an item to the dispenser (push).
		deferred
		ensure
			keep_reference: -- keep a copy of the item.
		end

	remove is
			-- Remove an item from the dispenser and update 
			-- the current item (pop).
		require
			meaningful: not is_empty
		deferred
		end

feature -- Conversion
	
	to_list : P_LIST[G] is
			-- Convert the dispenser to a list.
		deferred
		ensure
			valid_result: Result /= Void
			is_shallow_copy: -- new list but old items.
		end
	
end
