-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

indexing
	cluster: Pylon, Container
	description: "Linked list node"
	interface: internal

class P_LINKED_NODE[G]

inherit
	P_NODE[G]
		end

feature {P_LINKED_LIST, P_MUTATOR}
	
	previous, next : P_LINKED_NODE[G]
			-- Previous and next references.

feature {P_LINKED_LIST, P_MUTATOR}
	
	set_previous(pr : P_LINKED_NODE[G]) is
		do
			previous := pr
		end

	set_next(nx : P_LINKED_NODE[G]) is
		do
			next := nx
		end

	is_first : BOOLEAN is
			-- Is this node the first of a list?
		do
			Result := previous = Void
		end

	is_last : BOOLEAN is
			-- Is this node the last of a list? 
		do
			Result := next = Void
		end

end
