-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

indexing
	cluster: Pylon, Container
	description: "Container in which objects can be searched for"
	interface: abstract

deferred class P_SEARCHABLE[G,K]

inherit
	P_CONTAINER[G]
		end

feature -- Search

	search(x: K) is
			-- Search 'x' in the container, and set the current item
			-- to one of the container's item which is equal to 'x' if 
			-- successful. Equality as per is_equal.
		require
			readable: is_readable
		deferred
		end

	found : BOOLEAN is
			-- Result of the last search operation.
		deferred
		end
			
	found_count : INTEGER is
			-- Number of items found during the last search.
		require
			meaningful: found = true
		deferred
		ensure
			meaningful: Result >= 1
		end

end
