-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

indexing
	cluster: Pylon, Iteration
	description: "Linear levelorder iterator for forest trees"
	interface: client, internal

class P_TREE_LEVEL_ITERATOR[G]

inherit
	P_TREE_ITERATOR[G]
		end

creation {P_TREE}
	make

feature {NONE}
	
	initialize_iterator is
		do
			!P_QUEUE[P_TREE_NODE[G]]!disp.make
		end

	initialize_iteration(root : P_TREE_NODE[G]) is
		do
			disp.add(root) -- initqueue
			forth -- prepare first item
		end

feature
	
	forth is
		local
			child : P_TREE_NODE[G]
		do
			if not disp.is_empty then
				-- visit current node
				cur_node := disp.item
				disp.remove

				-- push children
				child := cur_node.first_child

				-- push from left to right
				from
				until
					child = Void
				loop
					disp.add(child)
					child := child.right
				end

				varcount := varcount - 1
			else -- finished
				cur_node := Void
				varcount := 0
			end
		end
	
end
